﻿Imports System.IO
Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic.Logging

Public Class Form1
    Private Sub btnGeneraCFDI40_Click(sender As Object, e As EventArgs) Handles btnGeneraCFDI40.Click
        Dim hXml As IntPtr


        ' indicamos la nueva version 4.0
        hXml = wrappers.VirtualXML_NewWithLog("4.0", "demoIngresoCFDI40.log")
        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")


        ' ejemplos de CFDI relacionados, NO SIEMPRE LOS LLEVA, revise la guia de llenado para mas informacion de estos parametor
        wrappers.VirtualXML_AddCfdiRelacionados_cfdi40(hXml, "01", "01000000-0000-0000-0000-000000000001", "01000000-0000-0000-0000-000000000002", "01000000-0000-0000-0000-000000000003", "", "", "", "", "", "", "")
        wrappers.VirtualXML_AddCfdiRelacionado_cfdi40(hXml, "01000000-0000-0000-0000-111111111111")
        wrappers.VirtualXML_AddCfdiRelacionados_cfdi40(hXml, "02", "02000000-0000-0000-0000-000000000001", "", "", "", "", "", "", "", "", "")
        wrappers.VirtualXML_AddCfdiRelacionado_cfdi40(hXml, "02000000-0000-0000-0000-222222222222")

        ' Datos generales del comprobante*/
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "CJZ", "7303", "%cb_date", "99", "CREDITO", "6034.48", "0.00", "MXN", "1", "7000.00", "I", "PPD", "07270", "", "01")
        ' datos del emisor
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")
        ' datos del receptor
        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "CTE940531F58", "CIBERNETICA Y TECNOLOGIA", "", "", "G03", "53050", "601")

        ' agregamos conceptos
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "43211500", "EQU-0025", "1.000", "H87", "Computadora", "COMPUTADORA HP PORTATIL", "6034.48", "6034.48", "0.00", "02")
        wrappers.VirtualXML_AddConceptoTraslado_cfdi40(hXml, "6034.48", "002", "Tasa", "0.160000", "965.52")  ' impuestos del concepto

        ' resumen de impuestos
        wrappers.VirtualXML_SetImpuestosInfo_cfdi40(hXml, "965.52", "")
        wrappers.VirtualXML_AddTraslado_cfdi40(hXml, "002", "Tasa", "0.160000", "965.52", "6034.48")

        ' generamos el CFDI
        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "demoIngresoCFDI40.xml")


        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)

    End Sub

    Private Sub btnGeneraPagos20_Click(sender As Object, e As EventArgs) Handles btnGeneraPagos20.Click
        Dim hXml As IntPtr

        ' indicamos la nueva version 4.0
        hXml = wrappers.VirtualXML_NewWithLog("4.0", "demoPagos20CFDI40.log")
        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "", "12629", "%cb_date", "", "", "0", "", "XXX", "", "0", "P", "", "72150", "", "01")
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")
        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "CTE940531F58", "CIBERNETICA Y TECNOLOGIA", "", "", "CP01", "53050", "601")
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "84111506", "", "1", "ACT", "", "Pago", "0", "0", "", "01")

        ' complemento de pagos 2.0
        wrappers.VirtualXML_SetPagos20(hXml, "", "", "", "18620.69", "2979.31", "", "", "", "", "", "21600.00")

        ' agregamos un pago
        wrappers.VirtualXML_Pagos20AddPago(hXml, "2022-01-10T01:01:01", "03", "MXN", "1", "10000.00", "0000842", "", "", "", "", "", "", "", "", "")
        ' agregamos un documento relacionado
        wrappers.VirtualXML_Pagos20AddPagoDoctoRelacionado(hXml, "8ADC78F8-4444-4444-4444-121212121212", "Serie", "0001", "MXN", "1", "1", "15000.00", "10000.00", "5000.00", "02")
        ' desgloce de impuestos del documento relacionado
        wrappers.VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR(hXml, "8620.69", "002", "Tasa", "0.160000", "1379.31")
        ' resumen de impuestos de todos los documentos relacionados
        wrappers.VirtualXML_Pagos20AddPagoImpuestosPTrasladoP(hXml, "8620.69", "002", "Tasa", "0.160000", "1379.31")

        ' agregamos otro pago
        wrappers.VirtualXML_Pagos20AddPago(hXml, "2022-01-01T10:01:01", "03", "MXN", "1", "11600.00", "0000843", "", "", "", "", "", "", "", "", "")
        wrappers.VirtualXML_Pagos20AddPagoDoctoRelacionado(hXml, "8ADC78F8-4AB4-44FC-34AD-121212121212", "Serie", "00002", "MXN", "1", "1", "11600.00", "11600.00", "0.00", "02")
        wrappers.VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR(hXml, "10000.00", "002", "Tasa", "0.160000", "1600.00")
        wrappers.VirtualXML_Pagos20AddPagoImpuestosPTrasladoP(hXml, "10000.00", "002", "Tasa", "0.160000", "1600.00")

        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "demoPagos20CFDI40.xml")


        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)


    End Sub

    Private Sub btnGeneraCartaPorte20_Click(sender As Object, e As EventArgs) Handles btnGeneraCartaPorte20.Click
        Dim hXml As IntPtr

        hXml = wrappers.VirtualXML_NewWithLog("4.0", "DemoCfdi40TrasladoCartaPorte20.log")

        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")

        ' primero creamos un CFDI de Traslado o de Traslado
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "CP", "001", "%cb_date", "", "", "0", "", "XXX", "", "0", "T", "", "02760", "", "01")

        ' datos del emisor
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")

        ' datos del receptor, uso del CFDI = S01
        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "", "", "S01", "26015", "601")

        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "12164502", "1158D10887", "1", "H87", "Pza", "Articulo 1", "0", "0", "", "01")
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "12164502", "1158D10887", "330", "H87", "Pza", "Articulo 2", "0", "0", "", "01")

        ' inicia Carta Porte 2.0
        wrappers.VirtualXML_SetCartaPorte20(hXml, "No", "", "", "", "2")

        ' Agregamos ubicaciones de origen y destino
        wrappers.VirtualXML_CartaPorte20AddUbicacion(hXml, "Origen", "OR101010", "EKU9003173C9", "", "", "", "", "", "", "2021-11-01T00:00:00", "", "", "calle origen 1", "211", "", "0347", "23", "", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddUbicacion(hXml, "Destino", "DE202020", "AAA010101AAA", "", "", "", "", "", "", "2021-11-01T01:00:00", "", "1", "calle destino 1", "214", "", "0347", "23", "entre av. lazaro cardenas y calle 32", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddUbicacion(hXml, "Destino", "DE202021", "AAA010101AAA", "", "", "", "", "", "", "2021-11-01T02:00:00", "", "1", "calle destino 2", "125", "", "0347", "23", "Zorro Abarrotero", "004", "COA", "MEX", "25350")

        ' Agregamos informacion de Mercancias
        wrappers.VirtualXML_CartaPorte20SetMercancias(hXml, "2.0", "XBX", "", "2", "")
        wrappers.VirtualXML_CartaPorte20AddMercancia(hXml, "11121900", "", "Mercancia 1", "1.0", "XBX", "", "", "Sí", "1266", "4H2", "", "1.0", "", "", "", "", "", "", "", "", "")
        wrappers.VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml, "1", "OR101010", "DE202020", "")
        wrappers.VirtualXML_CartaPorte20AddMercancia(hXml, "11121900", "", "Mercancia 2", "1.0", "XBX", "", "", "Sí", "1266", "4H2", "", "1.0", "", "", "", "", "", "", "", "", "")
        wrappers.VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml, "1", "OR101010", "DE202021", "")

        ' informacion del vehiculo que transporta las mercancias
        wrappers.VirtualXML_CartaPorte20SetMercanciasAutotransporte(hXml, "TPAF01", "NumPermisoSCT", "VL", "PLAC892", "2009", "Seguros Atlas", "123456789", "GNP Seguros", "123456789", "ABA Seguros", "", "", "CTR003", "PAX1234", "", "")

        ' finalmente agregamos las figuras de transporte
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml, "01", "PEMJ420113SG1", "a234567890", "Vazquez Armenta Macario", "", "", "", "Brisa", "423", "", "0347", "23", "Atras del estadio", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml, "02", "PEMJ420113SG1", "", "Fonseca Larrea Raul", "", "", "PT01", "Padre Lerchundi", "523", "", "0347", "23", "", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte(hXml, "PT02")
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml, "04", "PEMJ420113SG1", "", "", "", "", "", "Otra calle de prueba", "45", "", "0347", "23", "", "004", "COA", "MEX", "25350")

        ' generamos el CFDI
        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "DemoCfdi40TrasladoCartaPorte20.xml")


        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)


    End Sub

    Private Sub btnCancelaCFDI2022_Click(sender As Object, e As EventArgs) Handles btnCancelaCFDI2022.Click
        ' Archivo de log. Dejar vacio si no se desea generar
        Dim logName As String = "CancelaCFDI2022.log"
        ' Archivo de salida para resultados. Extension ini para formato INI, cualquier otro, pares de valores simples. Dejar vacio si no se desea generar
        Dim resName As String = "CancelaCFDI2022.ini"

        'uuid: "419012f3-48f6-45ed-9e96-69afb8adeae0", // 201, 202
        Dim exitCode As Int32 = wrappers.VirtualXML_CancelaCFDI2022(usuario:="demo_cibertec",
                rfcEmisor:="EKU9003173C9",
                motivo:="02",
                uuid:="00000000-48f6-45ed-9e96-69afb8adeae0",
                folioSustitucion:="",
                csdFilePath:="CSD_EKU9003173C9.cer",
                keyFilePath:="CSD_EKU9003173C9.key",
                keypwd:="12345678a",
                modoServer:="DEMO",
                outResult:=resName,
                outLog:=logName)

        Select Case exitCode
            Case 201
                MessageBox.Show(String.Format("ExitCode: {1}{0}Solicitud de cancelacion recibida exitosamente.", Environment.NewLine, exitCode), "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case 202
                MessageBox.Show(String.Format("ExitCode: {1}{0}UUID Previamente Cancelado.", Environment.NewLine, exitCode), "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case 205
                MessageBox.Show(String.Format("ExitCode: {1}{0}Error, El UUID no existe", Environment.NewLine, exitCode), "No Cancelable", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Case Else
                MessageBox.Show(String.Format("ExitCode: {1}{0}Error, consulte el archivo de resultados para mayor informacion", Environment.NewLine, exitCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Select


        If (System.IO.File.Exists(resName)) Then
            MessageBox.Show(System.IO.File.ReadAllText(resName), "Archivo de Resultados", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub btnGetStatusCFDI_Click(sender As Object, e As EventArgs) Handles btnGetStatusCFDI.Click
        ' Archivo de log. Dejar vacio si no se desea generar
        Dim logName As String = "log.txt"
        ' Archivo de salida para resultados. Extension ini para formato INI, cualquier otro, pares de valores simples. Dejar vacio si no se desea generar
        Dim resName As String = "resultados.ini"

        Dim exitCode As Int32 = wrappers.VirtualXML_GetStatusCFDI(usuario:="demo_cibertec",
                rfcEmisor:="AAA010101AAA",
                rfcReceptor:="VEME800513DU2",
                Total:="5000.00",
                uuid:="D3DB77B4-C328-4B13-8162-1C0142C73213",
                outResult:=resName,
                outLog:=logName,
                reserved:="")

        Select Case exitCode
            Case -3
                MessageBox.Show(String.Format("ExitCode: {1}{0}Error en el proceso.", Environment.NewLine, exitCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Case -2
                MessageBox.Show(String.Format("ExitCode: {1}{0}CFDI No encontrado", Environment.NewLine, exitCode), "NotFounded", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Case -1
                MessageBox.Show(String.Format("ExitCode: {1}{0}CFDI Cancelado (Con o sin aceptacion)", Environment.NewLine, exitCode), "Cancelado", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case 0
                MessageBox.Show(String.Format("ExitCode: {1}{0}CFDI Vigente, Cancelacion en Proceso (Con o sin aceptacion)", Environment.NewLine, exitCode), "Cancelacion en Proceso", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case 1
                MessageBox.Show(String.Format("ExitCode: {1}{0}CFDI Vigente No Cancelable", Environment.NewLine, exitCode), "No Cancelable", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case 2
                MessageBox.Show(String.Format("ExitCode: {1}{0}CFDI Vigente Cancelable (Con o sin aceptacion)", Environment.NewLine, exitCode), "Cancelable", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case Else
                MessageBox.Show(String.Format("ExitCode: {1}{0}CFDI ??? valor inesperado", Environment.NewLine, exitCode), "Valor Inesperado", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Select


        If (System.IO.File.Exists(resName)) Then
            MessageBox.Show(System.IO.File.ReadAllText(resName), "Archivo de Resultados", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub btnGeneraHonorarios_Click(sender As Object, e As EventArgs) Handles btnGeneraHonorarios.Click
        Dim hXml As IntPtr

        hXml = wrappers.VirtualXML_NewWithLog("4.0", "DemoCfdi40Nomina12.log")
        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")

        ' Datos generales del comprobante*/
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "NOM", "1234", "%cb_date", "", "", "8628.40", "2315.83", "MXN", "", "6312.57", "N", "PUE", "07270", "", "01")

        ' datos del emisor
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")

        ' datos del receptor, uso del CFDI = CN01, Regimen del receptor = 605
        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "FOSM380609Q76", "MARTIN FLORES SOLORZANO", "", "", "CN01", "53050", "605")

        ' concepto similar al concepto de Nomina 1.2, solo agregar 01 en objeto de impuestos
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "84111505", "", "1", "ACT", "", "Pago de nómina", "8628.40", "8628.40", "2315.83", "01")

        ' complmento de nomina se elabora similiar a como se hace en la version anterior
        wrappers.VirtualXML_SetNomina12(hXml, "O", "2022-01-01", "2022-01-15", "2022-01-15", "15", "8628.40", "2315.83", "0.00")
        wrappers.VirtualXML_Nomina12SetEmisor(hXml, "", "20035", "", "", "")
        wrappers.VirtualXML_Nomina12SetReceptor(hXml, "FOSM380609HDFLLR08", "01186258", "2022-01-01", "P15D", "01", "", "01", "02", "164", "UNIDAD DE APOYO ADMINISTRATIVA", "Director", "1", "04", "012", "2785594979", "8302.95", "546.00", "MEX")
        wrappers.VirtualXML_Nomina12SetPercepciones(hXml, "8628.40", "0.00", "0.00", "8210.40", "418.00")
        wrappers.VirtualXML_Nomina12AddPercepcion(hXml, "001", "001", "SUELDO BASE", "5560.80", "0.00", "", "", "", "", "", "")
        wrappers.VirtualXML_Nomina12AddPercepcion(hXml, "002", "002", "GRATIFICACION", "1581.15", "0.00", "", "", "", "", "", "")
        wrappers.VirtualXML_Nomina12AddPercepcion(hXml, "038", "016", "COMPENSACION POR RETABULACION", "1068.45", "0.00", "", "", "", "", "", "")
        wrappers.VirtualXML_Nomina12AddPercepcion(hXml, "029", "029", "DESPENSA", "0.00", "418.00", "", "", "", "", "", "")
        wrappers.VirtualXML_Nomina12SetDeducciones(hXml, "1116.65", "1199.18")
        wrappers.VirtualXML_Nomina12AddDeduccion(hXml, "001", "001", "CUOTAS DE SERVICIO DE SALUD", "349.65")
        wrappers.VirtualXML_Nomina12AddDeduccion(hXml, "001", "001", "CUOTAS AL SISTEMA SOLIDARIO DE REPARTO", "461.16")
        wrappers.VirtualXML_Nomina12AddDeduccion(hXml, "001", "001", "CUOTAS AL SISTEMA DE CAPITALIZACION INDIVIDUAL", "105.84")
        wrappers.VirtualXML_Nomina12AddDeduccion(hXml, "002", "002", "ISR", "1199.18")
        wrappers.VirtualXML_Nomina12AddDeduccion(hXml, "004", "004", "AHORRO VOLUNTARIO", "200.00")
        wrappers.VirtualXML_Nomina12AddOtroPago(hXml, "002", "CredSal", "Credito al Salario", "0.00", "", "", "", "0.00")


        ' generamos el CFDI
        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "DemoCfdi40Nomina12.xml")

        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)
    End Sub

    Private Sub btnGeneraCartaPorte20Ingreso_Click(sender As Object, e As EventArgs) Handles btnGeneraCartaPorte20Ingreso.Click
        Dim hXml As IntPtr

        hXml = wrappers.VirtualXML_NewWithLog("4.0", "DemoCfdi40IngresoCartaPorte20.log")

        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")

        ' Creamos un CFDI de ingreso 
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "CP2", "001", "%cb_date", "01", "", "25000.00", "", "MXN", "1", "28000.00", "I", "PUE", "06300", "", "01")

        ' datos del emisor
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")

        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "FOSM380609Q76", "MARTIN FLORES SOLORZANO", "", "", "G03", "53050", "612")


        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "78101500", "01", "1", "E48", "SERVICIO", "Flete de mercancias", "25000.00", "25000.00", "", "02")
        wrappers.VirtualXML_AddConceptoRetencion_cfdi40(hXml, "25000.00", "002", "Tasa", "0.040000", "1000.00")
        wrappers.VirtualXML_AddConceptoTraslado_cfdi40(hXml, "25000.00", "002", "Tasa", "0.160000", "4000.00")

        wrappers.VirtualXML_SetImpuestosInfo_cfdi40(hXml, "4000.00", "1000.00")
        wrappers.VirtualXML_AddRetencion_cfdi40(hXml, "002", "1000.00")
        wrappers.VirtualXML_AddTraslado_cfdi40(hXml, "002", "Tasa", "0.160000", "4000.00", "25000.00")

        ' inicia Carta Porte 2.0
        wrappers.VirtualXML_SetCartaPorte20(hXml, "No", "", "", "", "2")

        ' Agregamos ubicaciones de origen y destino
        wrappers.VirtualXML_CartaPorte20AddUbicacion(hXml, "Origen", "OR101010", "EKU9003173C9", "", "", "", "", "", "", "2021-11-01T00:00:00", "", "", "calle origen 1", "211", "", "0347", "23", "", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddUbicacion(hXml, "Destino", "DE202020", "CTE940531F58", "", "", "", "", "", "", "2021-11-01T01:00:00", "", "1", "calle destino 1", "214", "", "0347", "23", "entre av. lazaro cardenas y calle 32", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddUbicacion(hXml, "Destino", "DE202021", "FOSM380609Q76", "", "", "", "", "", "", "2021-11-01T02:00:00", "", "1", "calle destino 2", "125", "", "0347", "23", "Zorro Abarrotero", "004", "COA", "MEX", "25350")

        ' Agregamos informacion de Mercancias
        wrappers.VirtualXML_CartaPorte20SetMercancias(hXml, "2.0", "XBX", "", "2", "")
        wrappers.VirtualXML_CartaPorte20AddMercancia(hXml, "11121900", "", "Mercancia 1", "1.0", "XBX", "", "", "Sí", "1266", "4H2", "", "1.0", "", "", "", "", "", "", "", "", "")
        wrappers.VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml, "1", "OR101010", "DE202020", "")
        wrappers.VirtualXML_CartaPorte20AddMercancia(hXml, "11121900", "", "Mercancia 2", "1.0", "XBX", "", "", "Sí", "1266", "4H2", "", "1.0", "", "", "", "", "", "", "", "", "")
        wrappers.VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml, "1", "OR101010", "DE202021", "")

        ' informacion del vehiculo que transporta las mercancias
        wrappers.VirtualXML_CartaPorte20SetMercanciasAutotransporte(hXml, "TPAF01", "NumPermisoSCT", "VL", "PLAC892", "2009", "Seguros Atlas", "123456789", "GNP Seguros", "123456789", "ABA Seguros", "", "", "CTR003", "PAX1234", "", "")

        ' finalmente agregamos las figuras de transporte
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml, "01", "PEMJ420113SG1", "a234567890", "Vazquez Armenta Macario", "", "", "", "Brisa", "423", "", "0347", "23", "Atras del estadio", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml, "02", "PEMJ420113SG1", "", "Fonseca Larrea Raul", "", "", "PT01", "Padre Lerchundi", "523", "", "0347", "23", "", "004", "COA", "MEX", "25350")
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte(hXml, "PT02")
        wrappers.VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml, "04", "PEMJ420113SG1", "", "", "", "", "", "Otra calle de prueba", "45", "", "0347", "23", "", "004", "COA", "MEX", "25350")

        ' generamos el CFDI
        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "DemoCfdi40IngresoCartaPorte20.xml")

        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)
    End Sub

    Private Sub btnVentasDia_Click(sender As Object, e As EventArgs) Handles btnVentasDia.Click
        Dim hXml As IntPtr

        hXml = wrappers.VirtualXML_NewWithLog("4.0", "DemoIngresoCfdi40VentasDiarias.log")

        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")

        ' Datos generales del comprobante*/
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "CJZ", "7303", "%cb_date", "99", "CREDITO", "11500.00", "0.00", "MXN", "1", "13340.00", "I", "PPD", "07270", "", "01")

        ' Añadir nodo de informacion global
        wrappers.VirtualXML_SetInformacionGlobal_cfdi40(hXml, "01", "01", "2022")

        ' datos del emisor
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")

        ' datos del receptor, para publico en general RFC: XAXX010101000, nombre: "PUBLICO EN GENERAL" uso cfdi: "S01" y el mismo CP que emision del CFDI  
        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "XAXX010101000", "PUBLICO EN GENERAL", "", "", "S01", "07270", "616")

        ' agregamos conceptos
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "01010101", "TKT-001", "1", "ACT", "", "Venta", "1000.00", "1000.00", "0.00", "02")
        wrappers.VirtualXML_AddConceptoTraslado_cfdi40(hXml, "1000.00", "002", "Tasa", "0.160000", "160.00")  ' impuestos del concepto
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "01010101", "TKT-002", "1", "ACT", "", "Venta", "500.00", "500.00", "0.00", "02")
        wrappers.VirtualXML_AddConceptoTraslado_cfdi40(hXml, "500.00", "002", "Tasa", "0.160000", "80.00")  ' impuestos del concepto
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "01010101", "TKT-003", "1", "ACT", "", "Venta", "10000.00", "10000.00", "0.00", "02")
        wrappers.VirtualXML_AddConceptoTraslado_cfdi40(hXml, "10000.00", "002", "Tasa", "0.160000", "1600.00")  ' impuestos del concepto

        ' resumen de impuestos
        wrappers.VirtualXML_SetImpuestosInfo_cfdi40(hXml, "1840.00", "")
        wrappers.VirtualXML_AddTraslado_cfdi40(hXml, "002", "Tasa", "0.160000", "1840.00", "11500.00")

        ' generamos el CFDI
        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "DemoIngresoCfdi40VentasDiarias.xml")

        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)
    End Sub

    Private Sub btnPublicoGeneral_Click(sender As Object, e As EventArgs) Handles btnPublicoGeneral.Click
        Dim hXml As IntPtr

        hXml = wrappers.VirtualXML_NewWithLog("4.0", "DemoIngresoCfdi40PublicoGeneral.log")

        ' credenciales de timbrado
        ' credenciales de timbrado
        wrappers.VirtualXML_SetVirtualPACInfo(hXml, "demo_cibertec", "demo")

        ' Datos generales del comprobante*/
        wrappers.VirtualXML_SetComprobanteInfo_cfdi40(hXml, "CJZ", "7303", "%cb_date", "99", "CREDITO", "6034.48", "0.00", "MXN", "1", "7000.00", "I", "PPD", "07270", "", "01")
        ' datos del emisor
        wrappers.VirtualXML_SetEmisorInfo_cfdi40(hXml, "EKU9003173C9", "ESCUELA KEMPER URGATE", "601", "")

        ' datos del receptor, para publico en general RFC: XAXX010101000, cualquier nombre QUE NO SEA "PUBLICO EN GENERAL" uso cfdi: "S01" y el mismo CP que emision del CFDI  
        wrappers.VirtualXML_SetReceptorInfo_cfdi40(hXml, "XAXX010101000", "PONER CUALQUIER NOMBRE AQUI", "", "", "S01", "07270", "616")

        ' agregamos conceptos
        wrappers.VirtualXML_AddConcepto_cfdi40(hXml, "43211500", "EQU-0025", "1.000", "H87", "Computadora", "COMPUTADORA HP PORTATIL", "6034.48", "6034.48", "0.00", "02")
        wrappers.VirtualXML_AddConceptoTraslado_cfdi40(hXml, "6034.48", "002", "Tasa", "0.160000", "965.52")  ' impuestos del concepto

        ' resumen de impuestos
        wrappers.VirtualXML_SetImpuestosInfo_cfdi40(hXml, "965.52", "")
        wrappers.VirtualXML_AddTraslado_cfdi40(hXml, "002", "Tasa", "0.160000", "965.52", "6034.48")

        ' generamos el CFDI
        Dim nResultado As Int32 = wrappers.VirtualXML_ProcesaDocumento(hXml, "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "DemoIngresoCfdi40PublicoGeneral.xml")

        If nResultado = 0 Then
            For i = 1 To 21
                Dim getValue As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, i))
                MessageBox.Show(getValue, $"GetValue [{i}]", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Next
        Else
            Dim mErrorCode As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 1))
            Dim mError As String = Marshal.PtrToStringUni(wrappers.VirtualXML_GetValue(hXml, 2))
            MessageBox.Show($"Error en el CFDI: {mError}", mErrorCode, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        wrappers.VirtualXML_Free(hXml)
    End Sub

    Private Sub btnValidaDatosFiscales_Click(sender As Object, e As EventArgs) Handles btnValidaDatosFiscales.Click
        ' caso 1. Los datos fiscales son correctos 
        Dim nResult As Integer = wrappers.VirtualXML_MicroValidaDatosFiscales("VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc", "Microservices", "EKU9003173C9", "TCH850701RM1", "TIENDAS CHEDRAUI", "601", "11950", "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "ValidadoOK.INI", "ValidadoOK.LOG", "")

        If (nResult = 0) Then ' datos Then correctamente validados
            MessageBox.Show(File.ReadAllText("ValidadoOK.ini"), "Datos Validados Correctamente", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else

            MessageBox.Show(File.ReadAllText("ValidadoOK.log"), "Error en validación de datos fiscales", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        ' caso 2. Datos "parcialmente correctos", los datos son incorrectos, pero tenemos los datos fiscales en la base de datos */
        nResult = wrappers.VirtualXML_MicroValidaDatosFiscales("VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc", "Microservices", "EKU9003173C9", "NWM9709244W4", "WALMART", "601", "11950", "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "ValidadoErrorParcial.INI", "ValidadoErrorParcial.LOG", "")
        If nResult = 1 Then ' exito Then parcial

            Dim ini As String = File.ReadAllText("ValidadoErrorParcial.ini")
            Dim Log As String = File.ReadAllText("ValidadoErrorParcial.log")

            MessageBox.Show($"{ini}{Environment.NewLine}{Environment.NewLine}{Log}", "Datos Proporcionados incorrectos, pero tenemos los datos fiscales correctos", MessageBoxButtons.OK, MessageBoxIcon.Warning)

        Else

            MessageBox.Show(File.ReadAllText("ValidadoErrorParcial.log"), "Error en validación de datos fiscales", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        ' caso 3. Datos fiscales son incorrectos y no hay información fiscal en la base de datos */
        nResult = wrappers.VirtualXML_MicroValidaDatosFiscales("VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc", "Microservices", "EKU9003173C9", "FOLR670417KD6", "RAUL FLORES LANUS", "605", "07270", "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "ValidadoError.INI", "ValidadoError.LOG", "")
        MessageBox.Show($"Valor devuelto < 0{Environment.NewLine}{Environment.NewLine}{File.ReadAllText("ValidadoOK.log")}", "Error en validación de datos fiscales", MessageBoxButtons.OK, MessageBoxIcon.Error)
        If nResult < 0 Then ' error
        End If

    End Sub

    Private Sub btnConsultaDirectaRfc_Click(sender As Object, e As EventArgs) Handles btnConsultaDirectaRfc.Click

        '/* Busqueda exitosa */
        Dim nResult As Integer = wrappers.VirtualXML_MicroConsultaDatosFiscales("VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc", "Microservices", "EKU9003173C9", "NES220325179", "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "ConsultaOK.INI", "ConsultaOK.LOG", "")
        If nResult = 0 Then ' datos Then encontrados
            MessageBox.Show(File.ReadAllText("ConsultaOK.ini"), "Datos Fiscales encontrados", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else '// no se encontraron datos fiscales.
            MessageBox.Show(File.ReadAllText("ConsultaOK.log"), "No tenemos información sobre el RFC", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        ' busqueda no exitosa */
        nResult = wrappers.VirtualXML_MicroConsultaDatosFiscales("VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc", "Microservices", "EKU9003173C9", "LODJ360912Q76", "CSD_EKU9003173C9.cer", "CSD_EKU9003173C9.key", "12345678a", "ConsultaError.INI", "ConsultaError.LOG", "")
        MessageBox.Show(File.ReadAllText("ConsultaError.log"), "No tenemos información sobre el RFC", MessageBoxButtons.OK, MessageBoxIcon.Error)



    End Sub
End Class
